      subroutine hkfits(unitno,path,mmoriam,status)
      implicit none
      integer unitno,mmoriam,maxlin,status,nlines,i,j,k,stat,length,lno
      integer hklength,nstrt,jflag
      double precision dreslt
      real reslt
      parameter (maxlin=200)
      character path*(*),name*80,lines(maxlin)*80,string*80,keywrd*8
      common / data / lines,lno,nlines

      i=length(path)
      name(1:i)=path(1:i)
      if (path(i:i).eq.'/') then
       name(i+1:i+10)='hkfile.lis'
      else
       name(i+1:i+11)='/hkfile.lis'
      endif

      open (unit=99,file=name,iostat=stat,err=1,status='old',readonly)

1     if (stat.ne.0) then 
       write (*,*) 'Warning: failed to find file hkfile.lis'
       write (*,*) 
     :'No housekeeping information will be written to the FITS header'
      else
       nlines=0
10     nlines=nlines+1
       if (nlines.gt.maxlin) then
        write (*,*) 
     :'Warning: dimension MAXLIN in module hkfits.f exceeded.'
        write (*,*) 
     :'No. of lines read from housekeeping file = ',maxlin
        goto 20
       endif
       read (99,'(a)',end=20) lines(nlines)
       goto 10
20     close (99)
       nlines=nlines-1
       if (nlines.lt.1) then
        write (*,*) 'Warning: no lines read from file hkfile.lis'
        write (*,*) 
     :'No housekeeping information will be written to the FITS header'
       else

c  First transfer some useful hk info into standard FITS keywords:

        call kyfind('PLATE.PLATE ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         i=hklength(lines(lno))
         call ftpkys(unitno,'PLATENUM',lines(lno)(33:i),
     :'Plate number',status)
        endif
        call kyfind('PLATE.EMULSION ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         i=hklength(lines(lno))
         call ftpkys(unitno,'EMULSION',lines(lno)(33:i),
     :'Kodak emulsion type',status)
        endif
        call kyfind('PLATE.FILTER ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         i=hklength(lines(lno))
         call ftpkys(unitno,'FILTER',lines(lno)(33:i),
     :'Schott glass filter type',status)
        endif
        call kyfind('PLATE.PSCALE ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         i=hklength(lines(lno))
         call ftpkys(unitno,'PLTSCALE',lines(lno)(33:i),
     :'[arcsec/mm] plate scale',status)
        endif
        call kyfind('PLATE.FIELD ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         i=hklength(lines(lno))
         call ftpkys(unitno,'FIELDNUM',lines(lno)(33:i),
     :'Sky survey field number',status)
        endif
        call kyfind('PLATE.EPOCH ',8)
        if (lno.ne.0) then
         nstrt=33
         call sla_flotin(lines(lno),nstrt,reslt,jflag)
         if (jflag.le.0) call ftpkye(unitno,'EPOCH',reslt,6,
     :'Epoch of observation',status)
        endif
        call kyfind('PLATE.UTDATE ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         string(3:4)=lines(lno)(33:34)
         string(6:7)=lines(lno)(35:36)
         string(9:10)=lines(lno)(37:38)
         string(5:5)='-'
         string(8:8)='-'
         read (string,'(2x,i2)') i
         if (i.le.70) then
          string(1:2)='20'
         else
          string(1:2)='19'
         endif
         i=length(string)
         call ftpkys(unitno,'DATE-OBS',string(1:i),
     :'[yyyy-mm-dd] UT date of observation',status)
        endif
        call kyfind('PLATE.TELESCOP ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         i=hklength(lines(lno))
         call ftpkys(unitno,'TELESCOP',lines(lno)(33:i),
     :'Telescope on which the plate was taken',status)
        endif
        call kyfind('PLATE.TELTYPE ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         i=hklength(lines(lno))
         call ftpkys(unitno,'TELETYPE',lines(lno)(33:i),
     :'Type of telescope',status)
        endif
        call kyfind('PLATE.TELLAT ',8)
        if (lno.ne.0) then
         nstrt=33
         call sla_dfltin(lines(lno),nstrt,dreslt,jflag)
         if (jflag.le.0) call ftpkyd(unitno,'SITELAT',dreslt,12,
     :'[radians] latitude of telescope',status)
        endif
        call kyfind('PLATE.TELLONG ',8)
        if (lno.ne.0) then
         nstrt=33
         call sla_dfltin(lines(lno),nstrt,dreslt,jflag)
         if (jflag.le.0) call ftpkyd(unitno,'SITELONG',dreslt,12,
     :'[radians] longitude of telescope',status)
        endif
        call kyfind('PLATE.LST ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         string(1:2)=lines(lno)(33:34)
         string(4:5)=lines(lno)(35:36)
         string(3:3)=':'
         i=length(string)
         call ftpkys(unitno,'LST',string(1:i),
     :'[hh:mm] local sidereal time at start of obs',status)
        endif
        call kyfind('PLATE.MJD ',8)
        if (lno.ne.0) then
         nstrt=33
         call sla_dfltin(lines(lno),nstrt,dreslt,jflag)
         if (jflag.le.0) call ftpkyd(unitno,'MJD-OBS',dreslt,12,
     :'Modified Julian Date of observation',status)
        endif
        call kyfind('JOB.INSTRUME ',8)
        if (lno.ne.0) then
         write (string,'(80x)')
         i=hklength(lines(lno))
         call ftpkys(unitno,'INSTRUME',lines(lno)(33:i),
     :'Measuring machine',status)
        endif
        call kyfind('DATE-MES ',12)
        if (lno.ne.0) then
         write (string,'(80x)')
         string(1:4)=lines(lno)(33:36)
         string(6:7)=lines(lno)(38:39)
         string(9:10)=lines(lno)(41:42)
         string(5:5)='-'
         string(8:8)='-'
         i=length(string)
         call ftpkys(unitno,'DATE-MES',string(1:i),
     :'[yyyy-mm-dd] Date of this plate measurement',status)
        endif

c  Check the equinox and time system for the celestial co-ordinate solution,
c  and write the appropriate FITS keyword RADECSYS:

        call kyfind('XYTORADEC.R-EQUIN ',8)
        i=lno
        call kyfind('XYTORADEC.R-TSYS ',8)
        j=lno
        if (lines(i)(33:36).eq.'2000'.and.lines(j)(33:38).eq.
     :'JULIAN') then
         call ftpkys(unitno,'RADECSYS','FK5',
     :'Reference frame for RA/DEC',status)
        else if (lines(i)(33:36).eq.'1950'.and.lines(j)(33:41).eq.
     :'BESSELIAN') then
         call ftpkys(unitno,'RADECSYS','FK4',
     :'Reference frame for RA/DEC',status)
        endif

c  Then write entire hkfile contents to the FITS header:

        call ftpkyj(unitno,'NHKLINES',nlines,
     :'Number of lines from house-keeping file',status)
        do i=1,nlines
         string=lines(i)
         string(32:32)=' '
         j=8
         do while (string(j:j).ne.'''')
          j=j+1
         enddo
         string(j:j)=' '
         write (keywrd,'(a5,i3.3)') 'HKLIN',i
         j=hklength(string)
         k=min(j,73)
         call ftpkys(unitno,keywrd,string(8:k),' ',status)
        enddo

       endif
      endif

c  Write some HISTORY info:

      if (mmoriam.eq.1) then
       call ftpkys(unitno,'HISTORY',
     :'SuperCOSMOS mapping-mode (MM) data written using pix2fits.',
     :' ',status)
      else if (mmoriam.eq.2) then
       call ftpkys(unitno,'HISTORY',
     :'SuperCOSMOS image analysis mode (IAM) data written by iam2fits.',
     :' ',status)
      else if (mmoriam.eq.3) then
       call ftpkys(unitno,'HISTORY',
     :'SuperCOSMOS image analysis and mapping mode (IAM and MM) ',
     :' ',status)
       call ftpkys(unitno,'HISTORY','data written by pix2fits.',
     :' ',status)
      else
       call ftpkys(unitno,'HISTORY',
     :'SuperCOSMOS data written to FITS format',
     :' ',status)
      endif
      call ftpkys(unitno,'HISTORY',
     :'Any questions/comments/suggestions/bug reports should be sent',
     :' ',status)
      call ftpkys(unitno,'HISTORY','to N.Hambly@roe.ac.uk',' ',status)

      return
      end

      subroutine kyfind(value,strt)
      implicit none
      integer maxlin,i,j,lno,nlines,strt,length
      parameter (maxlin=200)
      character value*(*),lines(maxlin)*80
      common / data / lines,lno,nlines

      j=length(value)
      i=0
      lno=0
      do while (i.le.nlines.and.lno.eq.0)
       i=i+1
       if (lines(i)(strt:strt+j-1).eq.value(1:j)) lno=i
      enddo
    
      return
      end

      function hklength(string)
      implicit none
      character string*(*)
      integer i,hklength

      i=33
      do while (string(i:i).ne.'''')
       i=i+1
      enddo
      hklength=i-1
      return
      end
